package main

import (
	"bufio"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"github.com/pion/webrtc/v2"
	"os"
	"time"
)

func check(e error) {
	if e != nil {
		panic(e)
	}
}

func tx(dc *webrtc.DataChannel) {
//	raw, err := dc.Detach()
//	check(err)
	buf := make([]byte, 2000)
	ticker := time.NewTicker(20 * time.Millisecond)
                defer ticker.Stop()

	for i:=0; ; i++ {
		select {
		case <-ticker.C:
			err := dc.Send(buf)
			//err := raw.Write(buf)
			check(err)
		//	_, err := raw.Read(buf)
	//		check(err)
			if i%50 == 0 {
				fmt.Printf("tx %d\n", i)
			}
		}
	}
}

func main() {
	fmt.Println("offer?")
	r := bufio.NewReader(os.Stdin)
	s, err := r.ReadString('\n')

	m := webrtc.MediaEngine{}
	m.RegisterCodec(webrtc.NewRTPOpusCodec(webrtc.DefaultPayloadTypeOpus, 48000))
	se := webrtc.SettingEngine{}
	se.DetachDataChannels()
        api := webrtc.NewAPI(webrtc.WithMediaEngine(m), webrtc.WithSettingEngine(se))
	//api := webrtc.NewAPI(webrtc.WithMediaEngine(m))
	pc, _ := api.NewPeerConnection(webrtc.Configuration{})
	_, err = pc.AddTransceiver(webrtc.RTPCodecTypeAudio)
	check(err)

	pc.OnDataChannel(func(dc *webrtc.DataChannel) {
                fmt.Println("ondatachannel")
		dc.OnOpen(func() {
			tx(dc)
		})
/*func() {
			fmt.Printf("dc.onopen\n")
			tx(dc)
			//i := 0
			//raw, err := dc.Detach()
			//check(err)
			//buf := make([]byte, 2000)
			
			//for {
			//	err := dc.Send(buf)
                         //       check(err)
			//	_, err := raw.Read(buf)
		//		check(err)
		//		fmt.Printf("tx %d\n", i)
		//		i++
			//}
		})*/
		dc.OnClose(func() {
			fmt.Printf("dc.onclose\n")
		})
                /*dc.OnMessage(func(msg webrtc.DataChannelMessage) {
                        fmt.Printf("rx %d\n", i)
			i++
                })*/
        })

	pc.OnTrack(func(rxtrack *webrtc.Track, receiver *webrtc.RTPReceiver) {
                fmt.Printf("onTrack type=%d codec=%s \n",
                        rxtrack.PayloadType(), rxtrack.Codec().Name)
		for {
			_, err := rxtrack.ReadRTP()
			//fmt.Println("rtp")
			check(err)
		}
        })


/*
	dc, err := pc.CreateDataChannel("dc", nil)
	check(err)
	dc.OnOpen(func() {
		fmt.Printf("dc.onopen\n")
	})
	i := 0
	dc.OnMessage(func(msg webrtc.DataChannelMessage) {
		fmt.Printf("rx %d\n", i)
		i++
	})
*/

	pc.OnICEConnectionStateChange(func(connectionState webrtc.ICEConnectionState) {
		fmt.Printf("server: ICE state changed: %s\n", connectionState.String())
	})
	offer, err := base64.StdEncoding.DecodeString(s)
	var desc webrtc.SessionDescription
	json.Unmarshal([]byte(offer), &desc)
	err = pc.SetRemoteDescription(desc)
	check(err)
	answer, _ := pc.CreateAnswer(nil)
	pc.SetLocalDescription(answer)
	jsonans, _ := json.Marshal(answer) // or answer.SDP?
	fmt.Println("answer =", base64.StdEncoding.EncodeToString(jsonans))
	select {}
}
